#ifndef GEONETWORKING_LAYER_H
#define GEONETWORKING_LAYER_H
#include "Layer.hh"
#include "GeoNetworkingCodec.hh"

namespace LibItsGeoNetworking__TestSystem {
	class GeoNetworkingPort;
	class GeoNetworkingReq;
}

class GeoNetworkingLayer : public TLayer<LibItsGeoNetworking__TestSystem::GeoNetworkingPort> {
	GeoNetworkingCodec _codec;
    Params _params;
  public:
    inline GeoNetworkingLayer() : TLayer<LibItsGeoNetworking__TestSystem::GeoNetworkingPort>(), _codec(), _params() {}
    GeoNetworkingLayer(const std::string & type, const std::string & param);
    virtual ~GeoNetworkingLayer(){}

    void sendMsg(const LibItsGeoNetworking__TestSystem::GeoNetworkingReq&, const Params& param);

    virtual void sendData(const OCTETSTRING& data, const Params& params);
    virtual void receiveData(const OCTETSTRING& data, const Params& info);
};

#endif
